--# -path=.:../abstract:../../prelude

--1 The Top-Level Swedish Resource Grammar: Structural Words
--
-- Aarne Ranta 2002 -- 2003
--
concrete StructuralSwe of Structural = 
                      CombinationsSwe ** open Prelude, SyntaxSwe in {
 lin

  INP    = pronNounPhrase jag_32 ;
  ThouNP = pronNounPhrase du_33 ;
  HeNP   = pronNounPhrase han_34 ;
  SheNP  = pronNounPhrase hon_35 ;
  WeNumNP n = pronNounPhrase (pronWithNum vi_36 n) ;
  YeNumNP n = pronNounPhrase (pronWithNum ni_37 n) ;
  TheyNP = pronNounPhrase de_38 ;

  YouNP  = let {ni = pronNounPhrase ni_37 } in {s = ni.s ; g = ni.g ; n = Sg} ;

  ItNP   = pronNounPhrase det_40 ; ----
  ThisNP = regNameNounPhrase ["det hr"] Neutr NoMasc ; 
  ThatNP = regNameNounPhrase ["det dr"] Neutr NoMasc ; 
  TheseNumNP n = 
    {s = \\c => ["det hr"] ++ n.s ! npCase c ; g = Neutr ; n = Pl} ;
  ThoseNumNP n = 
    {s = \\c => ["det dr"] ++ n.s ! npCase c ; g = Neutr ; n = Pl} ;

  EveryDet = varjeDet ; 
  AllMassDet   = mkDeterminerSgGender2 "all" "allt" IndefP ; 
  AllNumDet  = mkDeterminerPlNum "alla" IndefP ; 
  AnyDet   = mkDeterminerSgGender2 "ngon" "ngot" IndefP ; 
  AnyNumDet  = mkDeterminerPlNum "ngra" IndefP ; 
  SomeDet  = mkDeterminerSgGender2 "ngon" "ngot" IndefP ; 
  SomeNumDet = mkDeterminerPlNum "ngra" IndefP ; 
  ManyDet  = mkDeterminerPl "mnga" IndefP ; 
  NoDet    = mkDeterminerSgGender2 "ingen" "inget" IndefP ; 
  NoNumDet   = mkDeterminerPlNum "inga" IndefP ; 
  WhichNumDet = mkDeterminerPlNum "vilka" IndefP ; 

  WhichDet = vilkenDet ;
  MostDet  = mkDeterminerSgGender2 ["den mesta"] ["det mesta"] (DefP Def) ;
  MostsDet = flestaDet ;
  MuchDet  = mkDeterminerSg (detSgInvar "mycket") IndefP ;

  ThisDet  = mkDeterminerSgGender2 ["den hr"] ["det hr"] (DefP Def) ;
  ThatDet  = mkDeterminerSgGender2 ["den dr"] ["det dr"] (DefP Def) ;
  TheseNumDet = mkDeterminerPlNum ["de hr"] (DefP Def) ; 
  ThoseNumDet = mkDeterminerPlNum ["de dr"] (DefP Def) ; 

  HowIAdv = ss "hur" ;
  WhenIAdv = ss "nr" ;
  WhereIAdv = ss "var" ;
  WhyIAdv = ss "varfr" ;

  AndConj  = ss "och" ** {n = Pl}  ;
  OrConj   = ss "eller" ** {n = Sg} ;
  BothAnd  = sd2 "bde" "och" ** {n = Pl}  ;
  EitherOr = sd2 "antingen" "eller" ** {n = Sg} ;
  NeitherNor = sd2 "varken" "eller" ** {n = Sg} ;
  IfSubj   = ss "om" ;
  WhenSubj = ss "nr" ;

  PhrYes = ss ["Ja ."] ;
  PhrNo = ss ["Nej ."] ;

  VeryAdv = ss "mycket" ;
  TooAdv = ss "fr" ;
  OtherwiseAdv = ss "annars" ;
  ThereforeAdv = ss "drfr" ;

  EverybodyNP  = let alla = table {Nom => "alla" ; Gen => "allas"} in
                   {s = \\c => alla ! npCase c ; g = Utr ; n = Pl} ;
  SomebodyNP   = nameNounPhrase (mkProperName "ngon" Utr Masc) ;
  NobodyNP     = nameNounPhrase (mkProperName "ingen" Utr Masc) ;
  EverythingNP = nameNounPhrase (mkProperName "allting" Neutr NoMasc) ; 
  SomethingNP  = nameNounPhrase (mkProperName "ngonting" Neutr NoMasc) ; 
  NothingNP    = nameNounPhrase (mkProperName "ingenting" Neutr NoMasc) ; 

  CanVV     = mkVerb "kunna" "kan" "kunn"  ** {isAux = True} ; ---
  CanKnowVV = mkVerb "kunna" "kan" "kunn"  ** {isAux = True} ; ---
  MustVV    = mkVerb "f"    "mste" "f"  ** {isAux = True} ; ---
  WantVV    = mkVerb "vilja" "vill" "vilj" ** {isAux = True} ; ---

  EverywhereNP = advPost "varstans" ;
  SomewhereNP = advPost "ngonstans" ;
  NowhereNP = advPost "ingenstans" ;

  AlthoughSubj = ss "fast" ;

  AlmostAdv = ss "nstan" ;
  QuiteAdv = ss "ganska" ;

  InPrep = ss "i" ;
  OnPrep = ss "p" ;
  ToPrep = ss "till" ;
  ThroughPrep = ss "genom" ;
  AbovePrep = ss "ovanfr" ;
  UnderPrep = ss "under" ;
  InFrontPrep = ss "framfr" ;
  BehindPrep = ss "bakom" ;
  BetweenPrep = ss "mellan" ;
  FromPrep = ss "frn" ;
  BeforePrep = ss "fre" ;
  DuringPrep = ss "under" ;
  AfterPrep = ss "efter" ;
  WithPrep = ss "med" ;
  WithoutPrep = ss "utan" ;
  ByMeansPrep = ss "med" ;
  PossessPrep = ss "av" ;
  PartPrep = ss "av" ;
  AgentPrep = ss "av" ;

}
